
Foreman - Bug #31897

Headline api feature per_page=all doesn't work for all resources

02/16/2021 04:49 PM - Daniel Kraemer

Status: New   

Priority: Normal   

Assignee:    

Category: API   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged: No Found in Releases: 2.3.2

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Wanted to use parameter per_page=all with /api/fact_values but dit not get any results.

❯ http --timeout 600  --json get "$FOREMAN_URL/api/fact_values" search="name = solute_apt_updates:

:available_updates::count" per_page=all | jq ".total, .per_page, .results|length" 

0

0

0

❯ http --timeout 600  --json get "$FOREMAN_URL/api/fact_values" search="name = solute_apt_updates:

:available_updates::count" per_page=10000 | jq ".total, .per_page, .results|length" 

0

10000

1014

 Same with api/hosts thin=true

❯ http --timeout 600  --json get "$FOREMAN_URL/api/hosts" thin=true per_page=all | jq ".total, .pe

r_page, .results|length" 

0

0

0

❯ http --timeout 600  --json get "$FOREMAN_URL/api/hosts" thin=true per_page=3000 | jq ".total, .p

er_page, .results|length" 

1055

3000

1055

❯ http --timeout 600  --json get "$FOREMAN_URL/api/hosts" thin=true | jq ".total, .per_page, .resu

lts|length" 

1055

2000

1055

 Since this was a headline feature of the 2.2.0 release and we just updated to 2.3.2. i was quite excited to use this.

Works fine without thin=true

❯ http --timeout 600  --json get "$FOREMAN_URL/api/hosts" | jq ".total, .per_page, .results|length

" 

1055

2000

1055

❯ http --timeout 600  --json get "$FOREMAN_URL/api/hosts" per_page=all | jq ".total, .per_page, .r

esults|length" 

1055

1055
1055

❯ http --timeout 600  --json get "$FOREMAN_URL/api/hosts" per_page=all search="name ~ dakr" | jq "

.total, .per_page, .results|length" 

1055

1055

6

 fyi http is the tool https://github.com/httpie/httpie

Ticket of feature: https://projects.theforeman.org/issues/29909

Related issues:

Related to Foreman - Refactor #29909: Support fetching all records in API Closed

Related to Foreman - Bug #35591: Can't use 'search' with fact_value via API Duplicate

History

#1 - 02/17/2021 07:55 AM - Daniel Kraemer

- Subject changed from Headline api feature per_page=all doen't work as expected to Headline api feature per_page=all doesn't work for all

ressources

#2 - 07/21/2021 06:36 PM - Ewoud Kohl van Wijngaarden

- Related to Refactor #29909: Support fetching all records in API added

#3 - 07/21/2021 06:38 PM - Ewoud Kohl van Wijngaarden

- Category set to API

#4 - 10/14/2022 11:34 AM - Ewoud Kohl van Wijngaarden

- Related to Bug #35591: Can't use 'search' with fact_value via API added

#5 - 11/29/2022 06:13 PM - Ewoud Kohl van Wijngaarden

- Subject changed from Headline api feature per_page=all doesn't work for all ressources to Headline api feature per_page=all doesn't work for all

resources
